﻿namespace $safeprojectname$.Features.User
{
	using AutoMapper;
	using Entities;
	using Infrastructure.MediatedControllers;
	using MediatR;
	using Mehdime.Entity;
	using System.Collections.Generic;
	using System.ComponentModel.DataAnnotations;
	using System.Linq;
	using System.Threading.Tasks;
	using Infrastructure.RequestHandlers;
	public class Details
	{
		public class Query : IAsyncRequest<Result>
		{
			public int? UserId { get; set; }
		}

		public class QueryHandler : AsyncDbContextQueryHandler<Query, Result, Model>
		{
			public QueryHandler(IDbContextScopeFactory aDbContextScopeFactory) : base(aDbContextScopeFactory) { }

			protected override async Task<Result> HandleInScope(Query aQuery, Model aModel)
			{
				Result result = await aModel.Users.Where(aUser => aUser.UserId == aQuery.UserId).ProjectToSingleOrDefaultAsync<Result>();

				result.ApprovalListTemplates = new List<Result.ApprovalListTemplate>();
				return result;
			}
		}

		public class Result : IAsyncRequest
		{
			public int UserId { get; set; }

			[Display(Name = "First Name")]
			public string FirstAndMiddleName { get; set; }
			public string LastName { get; set; }
			public List<ApprovalListTemplate> ApprovalListTemplates { get; set; }

			public class ApprovalListTemplate
			{
				public string Name { get; set; }
				public int RecipientCount { get; set; }
			}
		}

		public class UiController : MediatedAsyncGetController<Query, Result>
		{
			public UiController(IMediator aMediator) : base(aMediator) { }
		}

		public class MappingProfile : Profile
		{
			protected override void Configure()
			{
				CreateMap<User, Result>();
				//CreateMap<ApprovalListTemplate, Result.ApprovalListTemplate>();
			}
		}
	}
}