﻿namespace $safeprojectname$
{
	using Infrastructure;
	using Entities;
	using System.Web.Mvc;
	using System.Web.Optimization;
	using System.Web.Routing;
	using System.Data.Entity;

	public class MvcApplication : System.Web.HttpApplication
	{
		protected void Application_Start()
		{
			AreaRegistration.RegisterAllAreas();
			FilterConfig.RegisterGlobalFilters(GlobalFilters.Filters);
			RouteConfig.RegisterRoutes(RouteTable.Routes);
			BundleConfig.RegisterBundles(BundleTable.Bundles);

			// Replace Default ViewEngine with Feature version
			ViewEngines.Engines.Clear();
			ViewEngines.Engines.Add(new FeatureRazorViewEngine());

			//Replace Default Controller factor with Feature version
			//ControllerBuilder.Current.SetControllerFactory(new $safeprojectname$.Infrastructure.ControllerFactory());

			// Set Database Initializer
			Database.SetInitializer<Model>(new ModelInitializer());

			using (var model = new Model())
			{
				model.Database.Initialize(force: false);
			}
		}
	}
}