﻿namespace $safeprojectname$.Infrastructure.Extensions
{
	using Newtonsoft.Json;
	using System;
	using System.Web.Mvc;

	public static class ControllerExtensions
	{
		public static ActionResult RedirectToFeatureJson<TController>(this Controller aController, Object aRouteValues = null)
			where TController : Controller
		{
			return aController.JsonNet(new
			{
				redirect = aController.Url.Feature<TController>(aRouteValues)
			});
		}

		public static ContentResult JsonNet(this Controller aController, object aModel)
		{
			string serialized = JsonConvert.SerializeObject(aModel, new JsonSerializerSettings
			{
				ReferenceLoopHandling = ReferenceLoopHandling.Ignore
			});

			return new ContentResult
			{
				Content = serialized,
				ContentType = "application/json"
			};
		}
	}
}