﻿namespace $safeprojectname$.Infrastructure.Extensions
{
	using MoreLinq;
	using System.Collections.Generic;
	using System.Linq;
	using System.Web.Mvc;
	using System.Web.Routing;

	public static class LinkBuilder
	{

		public static void GetNamesFromController<TController>(out string aControllerName, out string aActionName) where TController : Controller
		{
			string fullname = typeof(TController).FullName;                //$safeprojectname$.Features.User.Create+UiController
			IEnumerable<string> lastTwo = fullname.Split('.').TakeLast(2); // User, Create+UiController
			aControllerName = lastTwo.First();                             // User
			aActionName = lastTwo.Last().Split('+').First();               // Create
		}

		public static string BuildUrlForController<TController>(RequestContext aRequestContext, object aRouteValues) where TController : Controller
		{
			string controllerName;
			string actionName;
			string url;

			GetNamesFromController<TController>(out controllerName, out actionName);

			if (aRouteValues == null)
			{
				url = $"{controllerName}/{actionName}";
			}
			else
			{
				var routeValueDictionary = new RouteValueDictionary(aRouteValues);
				routeValueDictionary.Add(key: "Controller", value: controllerName);
				routeValueDictionary.Add(key: "Action", value: actionName);
				var urlHelper = new UrlHelper(aRequestContext);
				url = urlHelper.Action(actionName, controllerName, routeValueDictionary);
			}
			return url;
		}
	}
}