﻿namespace $safeprojectname$.Infrastructure.MediatedControllers
{
	using System.Threading.Tasks;
	using System.Web.Mvc;
	using MediatR;
	using Extensions;

	public class MediatedAsyncGetPostController<TQuery, TCommand, TRedirectController> : MediatedAsyncGetController<TQuery, TCommand>
		where TQuery : IAsyncRequest<TCommand>
		where TCommand : IAsyncRequest
		where TRedirectController : Controller
	{
		public MediatedAsyncGetPostController(IMediator aMediator) : base(aMediator) { }

		[HttpPost]
		[ValidateAntiForgeryToken]
		public virtual async Task<ActionResult> Action(TCommand aCommand)
		{
			await Mediator.SendAsync(aCommand);

			return this.RedirectToFeatureJson<TRedirectController>();
		}
	}
}