﻿namespace $safeprojectname$.Infrastructure.MediatedControllers
{
	using System;
	using System.Linq;
	using System.Web.Mvc;
	using MediatR;
	using Extensions;

	public class MediatedGetPostController<TQuery, TCommand, TRedirectController> : MediatedGetController<TQuery, TCommand>
		where TQuery : IRequest<TCommand>
		where TCommand : IRequest
		where TRedirectController : Controller
	{
		public MediatedGetPostController(IMediator aMediator) : base(aMediator) { }

		[HttpPost]
		[ValidateAntiForgeryToken]
		public virtual ActionResult Action(TCommand aCommand)
		{
			Mediator.Send(aCommand);

			return this.RedirectToFeatureJson<TRedirectController>();
		}
	}
}