﻿namespace $safeprojectname$.Infrastructure.RequestHandlers
{
	using MediatR;
	using Mehdime.Entity;
	using System;
	using System.Data.Entity;
	using System.Threading.Tasks;
	public class AsyncDbContextCommandHandler<TCommand, TDbContext> : AsyncRequestHandler<TCommand>
	where TCommand : IAsyncRequest
	where TDbContext : DbContext
	{
		protected IDbContextScopeFactory DbContextScopeFactory { get; }

		public AsyncDbContextCommandHandler(IDbContextScopeFactory aDbContextScopeFactory)
		{
			DbContextScopeFactory = aDbContextScopeFactory;
		}

		protected override async Task HandleCore(TCommand aCommand)
		{
			using (var dbContextScope = DbContextScopeFactory.Create())
			{
				TDbContext dbContext = dbContextScope.DbContexts.Get<TDbContext>();

				await HandleInScope(aCommand, dbContext);
				await dbContextScope.SaveChangesAsync();
			}
		}

		protected virtual async Task HandleInScope(TCommand aCommand, TDbContext aDbContext)
		{
			await Task.FromException<NotImplementedException>(new NotImplementedException());
		}
	}
}