﻿namespace $safeprojectname$.Infrastructure.RequestHandlers
{
	using System;
	using MediatR;
	using Mehdime.Entity;
	using System.Data.Entity;
	using System.Threading.Tasks;

	public class AsyncDbContextQueryHandler<TQuery, TResponse, TDbContext> : IAsyncRequestHandler<TQuery, TResponse>
where TQuery : IAsyncRequest<TResponse>
where TResponse : IAsyncRequest
where TDbContext : DbContext
	{
		protected IDbContextScopeFactory DbContextScopeFactory { get; }

		public AsyncDbContextQueryHandler(IDbContextScopeFactory aDbContextScopeFactory)
		{
			DbContextScopeFactory = aDbContextScopeFactory;
		}

		public async Task<TResponse> Handle(TQuery aQuery)
		{
			using (var dbContextScope = DbContextScopeFactory.CreateReadOnly())
			{
				TDbContext dbContext = dbContextScope.DbContexts.Get<TDbContext>();

				return await HandleInScope(aQuery, dbContext);
			}
		}
		protected virtual async Task<TResponse> HandleInScope(TQuery aQuery, TDbContext aDbContext)
		{
			await Task.FromException<NotImplementedException>(new NotImplementedException());
			return default(TResponse);
		}
	}
}