﻿namespace $safeprojectname$.Infrastructure.RequestHandlers
{
	using MediatR;
	using Mehdime.Entity;
	using System;
	using System.Data.Entity;

	public class DbContextCommandHandler<TCommand, TDbContext> : RequestHandler<TCommand>
		where TCommand : IRequest
		where TDbContext : DbContext
	{
		protected IDbContextScopeFactory DbContextScopeFactory { get; }

		public DbContextCommandHandler(IDbContextScopeFactory aDbContextScopeFactory)
		{
			DbContextScopeFactory = aDbContextScopeFactory;
		}

		protected override void HandleCore(TCommand aCommand)
		{
			using (var dbContextScope = DbContextScopeFactory.Create())
			{
				TDbContext dbContext = dbContextScope.DbContexts.Get<TDbContext>();


				HandleInScope(aCommand, dbContext);
				dbContextScope.SaveChanges();
			}
		}

		protected virtual void HandleInScope(TCommand aCommand, TDbContext aDbContext)
		{
			throw new NotImplementedException();
#pragma warning disable CS0162 // Unreachable code detected
			return;
#pragma warning restore CS0162 // Unreachable code detected
		}
	}
}