﻿namespace $safeprojectname$.Infrastructure.RequestHandlers
{
	using MediatR;
	using Mehdime.Entity;
	using System;
	using System.Data.Entity;

	public class DbContextQueryHandler<TQuery, TResponse, TDbContext> : IRequestHandler<TQuery, TResponse>
		where TQuery : IRequest<TResponse>
		where TResponse : IRequest
		where TDbContext : DbContext
	{
		protected IDbContextScopeFactory DbContextScopeFactory { get; }

		public DbContextQueryHandler(IDbContextScopeFactory aDbContextScopeFactory)
		{
			DbContextScopeFactory = aDbContextScopeFactory;
		}

		public TResponse Handle(TQuery aQuery)
		{
			using (var dbContextScope = DbContextScopeFactory.CreateReadOnly())
			{
				TDbContext dbContext = dbContextScope.DbContexts.Get<TDbContext>();
				return HandleInScope(aQuery, dbContext);
			}
		}

		protected virtual TResponse HandleInScope(TQuery aCommand, TDbContext aDbContext)
		{
			throw new NotImplementedException(message: "Override this method in your Handler");
#pragma warning disable CS0162 // Unreachable code detected
			return default(TResponse);
#pragma warning restore CS0162 // Unreachable code detected
		}
	}
}