﻿namespace $safeprojectname$.Infrastructure.Tags
{
	using System.Linq;
	using System.Text.RegularExpressions;
	using HtmlTags;
	using HtmlTags.Conventions;
	using HtmlTags.Conventions.Elements;

	public class DefaultDisplayLabelBuilder : IElementBuilder
	{
		public bool Matches(ElementRequest aElementRequest)
		{
			return true;
		}

		public HtmlTag Build(ElementRequest aElementRequest)
		{
			return new HtmlTag(tag: "").NoTag().Text(BreakUpCamelCase(aElementRequest.Accessor.Name));
		}

		public static string BreakUpCamelCase(string aFieldName)
		{
			string[] patterns = new[]
			{
																"([a-z])([A-Z])",
																"([0-9])([a-zA-Z])",
																"([a-zA-Z])([0-9])"
												};
			string output = patterns.Aggregate(aFieldName,
							(aCurrent, aPattern) => Regex.Replace(aCurrent, aPattern, replacement: "$1 $2", options: RegexOptions.IgnorePatternWhitespace));
			return output.Replace(oldChar: '_', newChar: ' ');
		}
	}
}