﻿namespace $safeprojectname$.Infrastructure.Tags
{
	using System;
	using HtmlTags;
	using HtmlTags.Conventions;
	using HtmlTags.Conventions.Elements;

	public class EnumDropDownModifier : IElementModifier
	{
		public bool Matches(ElementRequest aElementRequest)
		{
			return aElementRequest.Accessor.PropertyType.IsEnum;
		}

		public void Modify(ElementRequest aElementRequest)
		{
			Type enumType = aElementRequest.Accessor.PropertyType;

			aElementRequest.CurrentTag.RemoveAttr(attribute: "type");
			aElementRequest.CurrentTag.TagName(tag: "select");
			aElementRequest.CurrentTag.Append(new HtmlTag(tag: "option"));
			foreach (var value in Enum.GetValues(enumType))
			{
				HtmlTag optionTag =
						new HtmlTag(tag: "option")
						.Value(value.ToString())
						.Text(Enum.GetName(enumType, value));
				aElementRequest.CurrentTag.Append(optionTag);
			}
		}
	}
}