﻿namespace $safeprojectname$.Infrastructure.Validation
{
	using System.Net;
	using System.Web.Mvc;
	using Newtonsoft.Json;

	public class ValidatorActionFilter : IActionFilter
	{
		public void OnActionExecuting(ActionExecutingContext aFilterContext)
		{
			if (!aFilterContext.Controller.ViewData.ModelState.IsValid)
			{
				if (aFilterContext.HttpContext.Request.HttpMethod == "GET")
				{
					var result = new HttpStatusCodeResult(HttpStatusCode.BadRequest);
					aFilterContext.Result = result;
				}
				else
				{
					var result = new ContentResult();
					string content = JsonConvert.SerializeObject(aFilterContext.Controller.ViewData.ModelState,
							new JsonSerializerSettings
							{
								ReferenceLoopHandling = ReferenceLoopHandling.Ignore
							});
					result.Content = content;
					result.ContentType = "application/json";

					aFilterContext.HttpContext.Response.StatusCode = 400;
					aFilterContext.Result = result;
				}
			}
		}

		public void OnActionExecuted(ActionExecutedContext aFilterContext)
		{

		}
	}
}